/**
* Ein Array, das sich mit Zufallszahlen initialisieren laesst.
*
* @author : Mirko Mumberg
* @version : 1.0  date 07.06.1997
*/
public class CArrayRandom extends CArray
{
	/**
	* Es wird der Konstruktor von CArray aufgerufen.
	* @param _Size Die Groesse des Arrays.
	* @param _Get Der Zaehler, der die Lesezugriffe zaehlt.
	* @param _Set Der Zaehler, der die Schreibzugriffe zaehlt.
	* @see CArray#CArray
	*/
	public CArrayRandom(int _Size, CCounter _Get, CCounter _Set)
	{
		super(_Size, _Get, _Set);
	}

	/**
	* Es wird der Konstruktor von CArray aufgerufen.
	* @param _Size Die Groesse des Arrays.
	* @see CArray#CArray
	*/
	public CArrayRandom(int _Size)
	{
		super(_Size);
	}

	/**
	* Es wird der Kopiekonstruktor von CArray aufgerufen.
	* @param _a Das CArray, aus dem die Werte kopiert werden sollen.
	* @see CArray#CArray
	*/
	public CArrayRandom(CArray _a)
	{
		super(_a);
	}

	/**
	* Setzt dir Groesse des Arrays neu.
	* @param Size Die neue Groesse des Arrays.
	*/
	public void setSize(int Size)
	{
		if (Size != m_Size)  super.setSize(Size);
	}

	/**
	* Initialisiert das Array mit Zufallszahlen von 0 bis Groesse-1. Keine Zahl kommt zweimal vor.
	*/
	public void InitDifferentNumbers()
	{
		for(int i = 0; i < m_Size; i++)
		{
			Set(i, GetDifferentNumber(i));
		}
	}

	/**
	* Initialisiert das Array mit Zufallszahlen von 0 bis Max. Zahlen kommen mehrfach vor.
	* @param Max Die oberste Zahl, die vorkommen darf.
	*/
	public void InitAllNumbers(int Max)
	{
		for(int i = 0; i < m_Size; i++)
		{
			Set(i, myRandom(Max));
		}
	}

	/**
	* Eine Zufallszahl bekommen, die noch nicht im Array vorhanden ist.
	* @param Position Die Position im Array, bis zu der das Array schon gefuellt ist.
	* @return Die neue Zufallszahl.
	*/
	protected int GetDifferentNumber(int Position)
	{
		int Number = myRandom(m_Size - 1);
		boolean NumberOK = false;

		while (!NumberOK)
		{
			NumberOK = true;
			for(int i = 0; i < Position; i++)
			{
				if(Number == m_Array[i])
				{
					NumberOK = false;
					i = Position;
					Number = myRandom(m_Size - 1);
				}
			} 
		}
		return Number;
	}

	/**
	* Erzeugt eine Zufallszahl zwischen 0 und Max.
	* @param Max Die oberste Zahl, die vorkommen darf.
	* @return Eine neue Zufallszahl.
	*/
	public int myRandom(int Max)	// Eine Random-Funktion mit der ich arbeiten kann
	{
		double x;

		x = Max * Math.random();
		return (int) Math.round(x);
	}

}
