import java.awt.*;
/**
* CCounter ist ein Zaehler, der von Label abgeleitet wurde. Es wird ein Label mit Text und Zaehlerteil dargestellt. Sobald der Zaehler im Programm geaendert wird, wird der Label neugezeichent. 
*
* @author Mirko Mumberg
* @version 1.0  date : 07.06.1997 
*/
public class CCounter extends Panel
{
	/**
	* m_nCounter enthaelt den Stand des Zaehlers.
	*/
	protected int m_Counter;
	/**
	* m_Label enthaelt den Text der vor dem Zaehlerstand steht.
	*/
	protected Label m_Label;

	/**
	* m_UpdateLabel enthaelt den Zaehlerstand der sich immer aendert.
	*/
	protected Label m_UpdateLabel;

	/**
	* Konstruktor vom Counter initialisiert den CounterText und setzt den Counter auf 0.
	* @param _Label Der Text der vor dem Zaehlerstand stehen soll.
	*/
	public CCounter(String _Label)
	{
		m_Label= new Label(_Label);
		m_Counter = 0;
		m_UpdateLabel = new Label( "   " + m_Counter + "         ");
		add(m_Label);
		add(m_UpdateLabel);
	}

	/*
	* Zeichnet den Counter neu.
	*/
	private void repaintNow()
	{
		m_UpdateLabel.setText(" " + m_Counter + "    "); 
	}

	/**
	* Erhoeht den Counter um 1.
	*/
	public void up()
	{
		m_Counter++;
		repaintNow();
	}

	/**
	* Erniedrigt den Counter um 1.
	*/
	public void down()
	{
		m_Counter--;
		repaintNow();
	}

	/**
	* Setzt den Counter auf einen neuen Wert.
	* @param x Der zusetzende Wert. 
	*/
	public void set(int x)
	{
		m_Counter = x;
		repaintNow();
	}

	/**
	* Gibt den Wert des Counters zurueck.
	* @return Der Wert des Counters.
	*/
	public int get()
	{
		return m_Counter;
	}

}

