/**
* Diese Klasse kann ein Integer-Array nach dem HeapSort-Verfahren sortieren.
*
* @author Mirko Mumberg
* @version 1.0  date : 07.06.1997 
*/
public class CHeapsortAlg extends CSortAlg
{
	/*
	* Vertauscht Werte
	*/
	private void sift(CArray a, int l, int r)
	{
		int i = l;
		int j = 2*i + 1;
		int j1 = j + 1;
		int x = a.Get(i);

		if (CompareLower(j, r) && CompareLower(a.Get(j), a.Get(j1)))
			j = j1;
		while (CompareLower(j, r+1) && CompareLower(x, a.Get(j)))
		{
			a.Set(i, a.Get(j));
			paint();
			i = j;
			j = 2 * j + 1;
			j1 = j + 1;
			if (CompareLower(j, r) && CompareLower(a.Get(j), a.Get(j1)))
				j = j1;
		}
		a.Set(i,x);
		paint();
	}

	/**
	* Sortiert das Array nach dem Heapsort-Algorithmuss durch.
	* @param a Das zusortierende Array.
	*/
	public void HeapSort(CArray a)
	{
		int len = a.getSize();
		int l = len / 2;
		int r = len - 1;
		
		while (CompareLower(0 ,l))
		{
			l--;
			sift(a,l,r);
		}
		while (CompareLower(0, r))
		{
			Swap(a,0,r);
			r--;
			sift(a,l,r);
		}
	}

	/**
	* Ruft die HeapSort-Methode auf.
	* @param a Das zusortierende Array.
	*/
	public void Sort(CArray a)
	{
		HeapSort(a);
	}

}

