/**
* Eine abstrakte Mutter-Klasse, die die Schnittstelle zur Zeichenflaeche(CSortCanvas) darstellt.
* Sie verwaltet den Vergleichszaehler und stellt die vielgebraucht Swap-Routine zur Verfuegung.
*
* @author Mirko Mumberg
* @version 1.0  date : 07.06.1997 
*/
public abstract class CSortAlg
{

	private CSortCanvas 	m_parent;	// Der CSortCanvas, auf dem gezeichnet werden soll.
	private CCounter	m_CounterCompare;// Der Vergleichszaehler.

	/**
	*Setzen der Zeichenflaeche und des Vergleichzaehlers.
	* @param _SortCanvas Die Zeichenflaeche, auf der das zusortierende Array grafisch dargestellt wird.
	* @param _Compare Der Counter, der als Vergleichszaehler genommen werden soll.
	*/
	public void setParent(CSortCanvas _SortCanvas, CCounter _Compare)
	{
		m_parent = _SortCanvas;
		m_CounterCompare = _Compare;
	}

	/**
	* Ruft die Pause zum Neuzeichnen des Array auf.
	* (Soll bei jedem Schreibzugriff auf des zusortierende Array aufgerufen werden).
	*/
	public void paint()
	{
		m_parent.paint();
	}

	/**
	* Vertauschen zweier Eintraege im Array.
	* @param a In dem Array soll getauscht werden.
	* @param i Position des ersten Wertes.
	* @param j Position des zweiten Wertes. 
	*/
	public void Swap(CArray a, int i, int j)
	{
		int Temp = a.Get(i);
		a.Set(i, a.Get(j));
		a.Set(j, Temp);
		paint();
	}

	/**
	* Vergleicht zwei Werte auf  l < r.
	* Erhoeht den Vergleichzaehler um 1.
	* @param l Erster Vergleichswert.
	* @param r Zweiter Vergleichswert.
	* @return true, wenn l < r, sonst false.
	*/
	public boolean CompareLower( int l, int r)
	{
		m_CounterCompare.up();
		if (l < r)
			return true;
		else return false;
	}

	/**
	* Abstrakte Methode, die die Sortierung durchfuehren soll.
	* @param a Das zusortierende Integer-Array.
	*/
	public abstract void Sort(CArray a);
}

