import java.awt.event.*;
import java.awt.*;
/**
* CSortChoice beinhaltet die Sortiermoeglichkeiten. Um die Aktivitaeten auszufuehren wird das Interface ItemListener implementiert.
*
* @author Mirko Mumberg
* @version 1.0  date : 07.06.1997 
*/
public class CSortChoice extends Choice implements ItemListener
{
	private CSortCanvas m_SortCanvas;
	/*
	* SortCanvas ist das CSortCanvas, in dem die Sortierung ausgefuehrt werden soll.
	*/

	/**
	* Der Konstruktor initialisiert den Choice und fuegt das Interface dazu.
	* @param SCanvas Ist ein CSortCanvas. In dem wird die Sortierung durchgefuehrt.
	*/
	public CSortChoice(CSortCanvas _SCanvas)
	{
		super();
		m_SortCanvas = _SCanvas;
		addItemListener(this);
		add("Quicksort");
		add("Bubblesort");
		add("Selectionsort");
		add("Insertionsort");
		add("Heapsort");
		add("Mergesort");
		add("NoSort");
		select(6);
	}

	/*
	* Stop einen alten SortierThreat und startet das ausgewaehlten Sortierverfahren.
	* @param SortAlg Die SortierAlgorithmuss-Klasse, mit der die Sortierung durchgefuehrt werden soll.
	*/
	private void SortStart(CSortAlg SortAlg)
	{
		m_SortCanvas.setSort(SortAlg);
		m_SortCanvas.init();
		m_SortCanvas.StartSort();
	}

	/**
	* Funktion aus der Schnittstelle ItemListener. Wird aufgerufen, wenn im Choice-Element eine Auswahl getroffen wird. Fuehrt die Sortierungen durch.
	* @param e Event, das vom Choice gesendet wird.
	*/
	public void itemStateChanged(ItemEvent e)
	{
		String cmd = e.getItem().toString();
		if(cmd.equals("Quicksort"))
		{
			CQuicksortAlg Sort;
			Sort = new CQuicksortAlg();
			SortStart(Sort);
		}
		if(cmd.equals("Bubblesort"))
		{
			CBubblesortAlg Sort;
			Sort = new CBubblesortAlg();
			SortStart(Sort);
 
		}
		if(cmd.equals("Selectionsort"))
		{
			CSelectionsortAlg Sort;
			Sort = new CSelectionsortAlg();
			SortStart(Sort);
		}
		if(cmd.equals("Insertionsort"))
		{
			CInsertionsortAlg Sort;
			Sort = new CInsertionsortAlg();
			SortStart(Sort);
		}
		if(cmd.equals("Heapsort"))
		{
			CHeapsortAlg Sort;
			Sort = new CHeapsortAlg();
			SortStart(Sort);
		}
		if(cmd.equals("Mergesort"))
		{
			CMergesortAlg Sort;
			Sort = new CMergesortAlg();
			SortStart(Sort);
		}
	}
	
}

